package dataservices;
import java.util.*;
import java.io.*;

public class Log
{
    private BufferedWriter out;
    private File file;

    public Log(String fileName)
    {
        file = new File(fileName);
        createFile();
    }

    public synchronized void logEvent(String log)
    {
        try
        {
            out = new BufferedWriter(new FileWriter(file.getPath(), true));
            out.write(log + "\n");
            out.close();
        }
        catch(IOException e)
        {
            System.out.println("Error writing the file " + e);
        }
    }

    //creates a new log file, deleting any previously created logs
    private void createFile()
    {
        if(file.exists())
            file.delete();
        try
        {
            file.createNewFile();
        }
        catch(IOException e)
        {
             System.out.println("Error creating the file " + e);
        }
    }
}