package dataservices;

import snmp.*;
import java.net.*;

public class SNMPPacketProcessor
{
    DatagramPacket udpPacket;

    public SNMPPacketProcessor()
    {
    }

    public SNMPMessageInfo extractSNMP(DatagramPacket udp)
    {
        udpPacket = udp;
        byte[] encodedMessage = udpPacket.getData();

        try
        {
            SNMPMessageInfo snmpInfo = new SNMPMessageInfo(udpPacket.getAddress(), udpPacket.getPort(), new SNMPMessage(SNMPBERCodec.extractNextTLV(encodedMessage,0).getValue()));
            return snmpInfo;
        }
        catch(Exception e){}

        return null;
    }

    public DatagramPacket createUDPResponse(SNMPMessageInfo message)
    {
        byte[] encodedMessage = message.getMessage().getBEREncoding();
        DatagramPacket response = new DatagramPacket(encodedMessage, encodedMessage.length, message.getIP(), message.getPort());

        return response;
    }

    public DatagramPacket createMessageReponse(SNMPMessageInfo messageInfo, String message)
    {
      SNMPMessage snmpMessage = messageInfo.getMessage();
      InetAddress remote_ip = messageInfo.getIP();
      int port = messageInfo.getPort();
      int version = 0;

      String community = messageInfo.getCommunity().toString();

      try
      {
        SNMPOctetString testName = new SNMPOctetString(message);    //testing string

        int errorStatus = 0;
        int errorIndex = 0;


        SNMPPDU pdu = snmpMessage.getPDU();

        SNMPSequence varList = pdu.getVarBindList();
        SNMPSequence responseVarList = new SNMPSequence();

        for (int i=0; i<varList.size(); i++)
        {
            //parse oid, supply the value for that oid
            SNMPObjectIdentifier oid = (SNMPObjectIdentifier)(((SNMPSequence)varList.getSNMPObjectAt(i)).getSNMPObjectAt(0));
            SNMPVariablePair nextPair = new SNMPVariablePair(oid, testName);
            responseVarList.addSNMPObject(nextPair);
        }

        int requestID = pdu.getRequestID();

        SNMPPDU responsePDU = new SNMPPDU(SNMPBERCodec.SNMPGETRESPONSE, requestID, errorStatus, errorIndex, responseVarList);

        SNMPMessage message2 = new SNMPMessage(version, community, responsePDU);
        byte[] messageEncoding = message2.getBEREncoding();

        return new DatagramPacket(messageEncoding, messageEncoding.length, remote_ip, port);
      }
      catch(SNMPBadValueException e)
      {
      }
      return null;
    }
}
