package dataservices;

import java.io.*;
import java.util.StringTokenizer;


public class SNMPProxyConfig
       implements SNMPProxyConstants
{
    private String community       = COMMUNITY;
    private String translationFile = TRANSLATION_FILE;
    private String logFile         = LOG_FILE;
    private String configFile      = CONFIG_FILE;
    private String pomesIP         = POMES_IP;
    private int    pomesPort       = POMES_PORT;
    private int    resposneTimeout = RESPONSE_TIMEOUT;
    private int    listenPort      = UDP_PORT;
    private String name            = NAME;
    private String password        = PASSWORD;
    private int sessionTimeout     = SESSION_TIMEOUT;

    private boolean isPresent( String file )
    {
        File config = new File(file);
        return config.exists();
    }

    public String getCommunity()        { return community;       }
    public String getTranslationFile()  { return translationFile; }
    public String getLogFile()          { return logFile;         }
    public String getPomesIP()          { return pomesIP;         }
    public int getPomesPort()           { return pomesPort;       }
    public int getSessionTimeout()      { return sessionTimeout;  }
    public int getResponseTimeout()     { return resposneTimeout; }
    public int getListenPort()          { return listenPort;      }
    public String getName()             { return name;            }
    public String getPassword()         { return password;        }

   public boolean loadArguments(String [] args)
   {
     return true;
   }

    public boolean loadConfigFile()
    {
      String file = CONFIG_FILE;

      if( isPresent(file) )
      {
        try
        {
          BufferedReader in
          = new BufferedReader( new FileReader(file) );

          String s;
          StringTokenizer t;
          String temp;

          while( ( s = in.readLine() ) != null )
          {
            t = new StringTokenizer( s, "=" );

            if( t.hasMoreTokens() && t.countTokens() == 2 )
            {
              temp = t.nextToken();

              if( temp.equals( "community" ) )
                community = t.nextToken().trim();

              else if( temp.equals( "translationFile" ) )
                translationFile = t.nextToken().trim();

              else if( temp.equals( "logFile" ) )
                logFile = t.nextToken().trim();

              else if( temp.equals( "pomesIP" ) )
                pomesIP = t.nextToken().trim();

              else if( temp.equals("listenPort") )
                listenPort = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("pomesPort") )
                pomesPort = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("sesionTimeout") )
                sessionTimeout = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("responseTimeout") )
                resposneTimeout = Integer.parseInt( t.nextToken().trim() );

              else if( temp.equals("name") )
                name = t.nextToken().trim();

              else if( temp.equals("password") )
                password = t.nextToken().trim();
            }
          }
        }
        catch( IOException e )
        {
          System.out.println(e.toString());
        }
        return true;
      }
      return false;
    }

    public String toString()
    {
        String temp = "";
        temp += "community = " + community;
        temp += "translationFile = " + translationFile;
        temp += "logFile = " + logFile;
        temp += "pomesIP = " + pomesIP;
        temp += "pomesPort = " + pomesPort;
        temp += "sessionTimeout = " + sessionTimeout;
        temp += "listenPort = " + listenPort;
        return temp;
    }
}