package dataservices;

import snmp.*;
import java.util.*;

public class SNMPSecurityManager
{
  private String communityName;
  private String securityToken;
  private Log proxyLog;
  private static final String DEFAULT_COMMUNITY = "public";
  private static final String DEFAULT_TOKEN = "abcdefg";

  public SNMPSecurityManager(Log l)
  {
    proxyLog = l;
    this.setCommunityName(DEFAULT_COMMUNITY);
    this.setPOMESSecurityToken(DEFAULT_TOKEN);
  }

  public void setCommunityName(String name)
  {
     communityName = name;
     proxyLog.logEvent("Community Set to " + communityName);
  }
  public String getCommunityName()
  {
    return communityName;
  }

  public void setPOMESSecurityToken(String name)
  {
    securityToken = name;
    proxyLog.logEvent("Token Set to " + communityName);
  }

  public String getPOMESSecurityToken()
  {
    return securityToken;
  }

  public boolean verifyCommunityName(SNMPOctetString name)
  {
    return communityName.equals(name.toString());
  }
}