package dataservices;

import java.util.*;
import java.lang.*;
import java.net.InetAddress;

import communicationservices.*;
import dataservices.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Christopher M. King (kingc@uci.edu)
 * @version 0.5
 */

public class SNMPSessionManager extends Thread
{
  Vector openSessions = new Vector();
  private boolean debug = false;
  SNMPProxyConfig config;

  public SNMPSessionManager(SNMPProxyConfig cfg)
  {
    config = cfg;
    this.start();
  }

  /**
   * Starts a thread for the SNMPSessionManager that counts down time by one
   * second at a time, calling the tick() function on every Session it is
   * managing and timing out Sessions that have expired (i.e. have had no
   * activity for over a specified time)
   *
   * @see Session
   */
  public void run()
  {
    while(true)
    {
      tick();
      try
      {
        this.sleep(1000);
      }
      catch(Exception e)
      {
        System.out.println();
      }
    }
  }

  public SNMPSession openSNMPSession(InetAddress ip)
  {
    SNMPSession s = new SNMPSession(config, ip);
    openSessions.add(s);
    return s;
  }

  public void closeSNMPSession(InetAddress ip, int port)
  {
    SNMPSession curSession;
    for(int i=0; i<openSessions.size(); i++)
    { curSession = (SNMPSession)openSessions.elementAt(i);
      if(curSession.getIP() == ip && curSession.getPort() == port)
        openSessions.remove(curSession);
    }
  }
  public SNMPSession findSNMPSession(InetAddress ip)
  {
    SNMPSession curSession = null;
    for(int i=0; i<openSessions.size(); i++)
    { curSession = (SNMPSession)openSessions.elementAt(i);
      if(curSession.getIP().equals(ip))
        return curSession;
    }
    return null;
  }

  private void tick()
  {
    SNMPSession curSession;
    for(int i=0; i<openSessions.size(); i++)
    { curSession = (SNMPSession)openSessions.elementAt(i);
      curSession.tick();
      if(curSession.hasExpired())
        openSessions.remove(curSession);
    }
  }

  public String toString()
  {
    String temp = "";
    for(int i=0; i<openSessions.size(); i++)
      temp += openSessions.elementAt(i).toString();
    return temp;
  }
}