package dataservices;

import java.io.*;
import java.net.*;

public class XMLCommandProcessor
{
	//form Get commands (non-device specific)
	public String formCommand4Get (String cmdString)
        {
                System.out.println(cmdString);
		String command = cmdString.substring(0,3)+cmdString.substring(8, cmdString.length());
		String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                                 + "<POM-API>\n"
                                 + "    <COMMAND name=\""+ command + "\" />\n"
                                 + "</POM-API>" + (char)(06);
		return xmlString;
	}

	//form Get commands (device specific)
	public String formCommand4Get (String cmdString, String deviceip)
	{
		String command = cmdString.substring(0,3)+cmdString.substring(8, cmdString.length());
		String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                                 + "<POM-API>\n"
                                 + "    <COMMAND name=\""+ command + "\" " + "device=\"" + deviceip + "\" />\n"
			         + "</POM-API>" + (char)(06);

		return xmlString;
	}
	//form Set commands (non-device specific)
	public String formCommand4Set (String cmdString, String attributeString, String valueString)
	{
		String command = cmdString.substring(4,7)+cmdString.substring(8, cmdString.length());

                  String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                                   + "<POM-API>\n"
                                   + "    <COMMAND name=\""+ command + "\" " + attributeString + "=\"" + valueString + "\" />\n"
                                   + "</POM-API>" + (char)(06);
		return xmlString;
	}

	// form Set commands (device specific)
	public String formCommand4Set (String cmdString, String deviceip, String attributeString, String valueString)
	{
          String command = cmdString.substring(4,7)+cmdString.substring(8, cmdString.length());
          String xmlString = "";

          if(attributeString.equals("") || valueString.equals(""))
          {
            xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                      + "<POM-API>\n"
                      + "    <COMMAND name=\""+ command + "\" " + "device=\"" + deviceip + "\"/>\n"
                      + "</POM-API>" + (char)(06);
          }
          else
          {
            xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                      + "<POM-API>\n"
                      + "    <COMMAND name=\""+ command + "\" " + "device=\"" + deviceip + "\" " + attributeString + "=" + valueString + " />\n"
                      + "</POM-API>" + (char)(06);
          }
          return xmlString;
	}

        public String formCmd4SetSMTPAlertEntry(String deviceip, String entryid, String emaddress, String mask)
        {
          String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                           + "<POM-API>\n"
                           + "    <COMMAND name=\"SetSMTPAlertInformationEntry\"" + " device=\"" + deviceip + "\" >\n"
                           + "           <SMTPAlertEntry  entryid=\""  + entryid + "\" emaddress=\"" + emaddress + "\" mask=\"" + mask + "\"/>\n"
                           + "    </COMMAND>"
                           + "</POM-API>" + (char)(06);
          return xmlString;
        }
 
        public String formCmd4SetSNMPAlertEntry(String deviceip, String entryid, String emaddress, String mask)
        {
          String xmlString = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"
                           + "<POM-API>\n"
                           + "    <COMMAND name=\"SetSNMPTrapInformationEntry\"" + " device=\"" + deviceip + "\" >\n"
                           + "           <SNMPTrapEntry  entryid=\""  + entryid + "\" emaddress=\"" + emaddress + "\" mask=\"" + mask + "\"/>\n"
                           + "    </COMMAND>"
                           + "</POM-API>" + (char)(06);
          return xmlString;
        }
}